# Alarm Flight UI - Version 5

## ROS package

Perquisites:
```bash
wget https://repo.anaconda.com/archive/Anaconda3-2021.11-Linux-x86_64.sh
chmod +x ./Anaconda3-2021.11-Linux-x86_64.sh
./Anaconda3-2021.11-Linux-x86_64.sh
```
More anaconda installation options (for ARM64 etc):
https://www.anaconda.com/products/individual

After installing anaconda restart Terminal app.

:warning: For this version also Chromium browser is needed!
```bash
sudo apt install chromium-browser
```

Installation (recommended to re-install after every major version update)
```bash

cd /path/root/workspace

sudo chmod a+wr -R ~/.conda
conda remove --name alarm_flight_ui --all
conda env create --file ./src/alarm_flight_ui/scripts/environment.yml

chmod +x ./src/alarm_flight_ui/scripts/main.py

catkin_make
```

## Update installation

override `./src/alarm_flight_ui/scripts` contents

```bash
conda remove --name alarm_flight_ui --all
conda env create --file ./src/alarm_flight_ui/scripts/environment.yml

chmod +x ./src/alarm_flight_ui/scripts/main.py
```

## Launch package

```bash
conda activate alarm_flight_ui
source ./devel/setup.sh
roslaunch alarm_flight_ui main.launch
```

## Troubleshooting ROS package

There might be problem if you are running ROS using docker. Chromium browser need permission to access networking. It might be needed to commit image and re-create docker container. 

```bash
sudo docker commit [image_name]
sudo docker run --privileged [image_name]
```

## Troubleshooting other problems

Please if you experience issues send screenshots and `./logs/` files for us to analyze.

## Usage

Use File menu on top left corner to load PLY + TXT or pre-prepared Project file (*.flight). Then use ==double click== on map to add new POIs or select existing ones. When POI is created or selected use menus on right side panel to engage with them.

![image-20220405152624929](http://share.yellowrobot.xyz/upic/6248e0b89238556fe243d733b2bfbbc4_1652261094.png)

## Without ROS package

Installation

```bash
conda remove --name alarm_flight_ui --all
conda env create --file ./src/alarm_flight_ui/scripts/environment.yml
conda activate alarm_flight_ui
```

Launch using

```bash
python ./scripts/main.py
```

## Debugging in PyCharm

Use ./scripts as content root for the project



## Flight plan

With a function to have repeated loops

![image-20220511122444492](http://share.yellowrobot.xyz/upic/e3a98eccb7b3ee80c2f3c0b3f01af7c2_1652261086.png)

Added Rovio reset button in lower bottom panel

![image-20220511152649857](http://share.yellowrobot.xyz/upic/573b1cb5197aeac99e79dc82f0d015f0_1652272012.png)

To reset the map use "Clear all" button
![image-20220511152818214](http://share.yellowrobot.xyz/upic/b11849f946f2c9330c3726eef04eef3d_1652272099.png)