class SortableFlightPlanPOIs extends React.Component {
    componentDidMount() {
        this.jSortable = $(this.refs.sortable);
        this.jSortable.sortable({
            handle: ".handle",
            opacity: this.props.opacity,
            update: (event, ui) => {
                let uuids_order = $.map($('.sortable-pois'), it => $(it).attr("data-uuid"));
                eel.change_pois_order(uuids_order);
            }
        });
    }

    componentWillReceiveProps(nextProps) {
        if (nextProps.enable !== this.props.enable) {
            this.jSortable.sortable(nextProps.enable ? 'enable' : 'disable');
        }
    }

    renderItems() {
        let result = <></>;
        if(this.props.pois) {
            result = this.props.pois.map((poi, i) =>
                <div className="flight_plan_poi_row">
                    {this.props.isFlightPlanExecuting ? <span>&nbsp;</span> : <i class="material-icons handle"
                       style={{
                           alignSelf: "center",
                           cursor: "move",
                    }}>more_vert</i>}
                    <li key={poi.uuid} data-uuid={poi.uuid} className="ui-state-default sortable-pois">
                        <ComponentFlightPlanPoi
                            poi={poi}
                            name={poi.name}
                            status={poi.status}
                            isFlightPlanExecuting={this.props.isFlightPlanExecuting}
                            onChangeName={(name, uuid) => this.props.onChangeNameClick(name, uuid)}
                        />
                    </li>
                </div>
            );
        }
        return result;
    }

    render() {
        return (
            <ul ref="sortable" style={{listStyle: "none", paddingLeft: 0}}>
                {this.renderItems()}
            </ul>
        );
    }

    componentWillUnmount() {
        this.jSortable.sortable('destroy');
    }
};

SortableFlightPlanPOIs.defaultProps = {opacity: 1, enable: true};

SortableFlightPlanPOIs.propTypes = {
    opacity: React.PropTypes.number,
    enable: React.PropTypes.bool,
    onChange: React.PropTypes.func.isRequired
};