class DialogFlightPlan extends React.Component {
    constructor(props) {
        super(props);


    }

    onClose = () => {
        this.props.onClose();
    }

    onExecute = () => {
        if(this.props.isFlightPlanExecuting) {
            if(this.props.onStopFlightPlan) {
                this.props.onStopFlightPlan();
            }
        }
        else {
            this.props.project.map_layers.layer_pois.current_loop_count = 0;
            eel.add_log("INFO", "Flight plan executing...");
            if (this.props.project) {
                for (let poi of this.props.project.map_layers.layer_pois.pois) {
                    poi.status = "Pending";
                }
            }
            if (this.props.onExecutePlan) {
                this.props.onExecutePlan();
            }
        }
    }



    handleChangeName = (name, uuid) => {
        this.props.onChangeNameOpen(name, uuid);
    }

    handleOnChange(event, ui) {
        // console.log('DOM changed!', event, ui);
    }

    render = () => {
        const style = {
            width: 600,
            backgroundColor: "#f3f3f3",
            border: '2px solid #000',
            borderTop: 0,
            p: 4,
            borderRadius: "0 0 18px 18px",
        };

        const contain_style = {
            position: 'absolute',
            top: '50%',
            left: '50%',
            width: "auto",
            transform: 'translate(-50%, -50%)',
        }

        const title_bar_style = {
            fontSize: "102%",
            fontFamily: 'Space Grotesk',
            fontWeight: "600",
            letterSpacing: "0.5px",
            lineHeight: "25px",
            textAlign: "center",
            width: 600,
            backgroundColor: "#fff",
            border: '2px solid #000',
            borderBottom: 0,
            p: 1,
            borderRadius: "18px 18px 0 0",
        }

        const grid_container = {
            fontFamily: 'Space Grotesk',
            fontWeight: 600,
            fontSize: "115%",
            display: "grid",
            gridTemplateColumns: "1fr 1fr 3fr",
            justifyItems: "center",
            marginBottom: "10px",
        }

        let value_repeat_count = "1";
        if(this.props.project) {
            if(!this.props.project.map_layers.layer_pois.repeat_count) {
                this.props.project.map_layers.layer_pois.repeat_count = 1;
            }
            value_repeat_count = this.props.project.map_layers.layer_pois.repeat_count.toString();
        }
        if(this.props.isFlightPlanExecuting) {
            if(!this.props.project.map_layers.layer_pois.current_loop_count) {
                this.props.project.map_layers.layer_pois.current_loop_count = 0;
            }
            value_repeat_count = `${this.props.project.map_layers.layer_pois.current_loop_count} / ${value_repeat_count}`;
        }

        return (
            <div>
                <Modal
                    open={this.props.isOpen}
                    onClose={this.onClose}
                >
                    <Grid container spacing={0} alignItems="center" direction="column" style={contain_style}>
                        <Grid item sx={title_bar_style}>Flight Plan</Grid>
                        <Grid item sx={style}>
                            <div style={grid_container}>
                                <div style={{placeSelf: "end", paddingRight: "4px"}}>Name</div>
                                <div style={{placeSelf: "end", paddingRight: "10px"}}>status</div>
                                <div>Actions</div>
                            </div>
                            <div className="pois_wrapper_style">
                                <SortableFlightPlanPOIs
                                    pois={this.props.project && this.props.project.map_layers.layer_pois.pois}
                                    onChange={this.handleOnChange}
                                    isFlightPlanExecuting={this.props.isFlightPlanExecuting}
                                    onChangeNameClick={(name, uuid) => this.handleChangeName(name, uuid)}/>
                            </div>
                            <div className="pois_loop_box">
                                 <TextField variant="outlined"
                                   value={value_repeat_count}
                                   onChange={(e) => {
                                       try {
                                           this.props.project.map_layers.layer_pois.repeat_count = parseInt(e.target.value);
                                           eel.update_pois_repeat_count(this.props.project.map_layers.layer_pois.repeat_count);
                                           this.setState({});
                                       } catch (e) {
                                       }
                                   }}
                                   disabled={this.props.isFlightPlanExecuting}
                                   label={"Repeated loop Count"}
                                   sx={{
                                        backgroundColor: '#fff',
                                        border: "1px solid #D5DADC",
                                        borderRadius: "5px",
                                        margin: "0 10px",
                                        width: "240px"
                                    }}/>
                            </div>
                            <Button variant="action" style={{padding: "4%"}} onClick={this.onClose}>Close</Button>
                            <Button variant="action" style={{padding: "4%"}} onClick={this.onExecute}>
                                {this.props.isFlightPlanExecuting ? "Stop plan" : "Execute plan"}</Button>
                        </Grid>
                    </Grid>
                </Modal>
            </div>
        );
    }
}